#ifndef _HEADERS_DEFINITIONS_H
#define _HEADERS_DEFINITIONS_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define TitleCaption  "SQL-Exchange Server"
#define FileVersion   "1.0.0.0"
#define RegistryKey   "Software\\Enginuity\\SQL-Exchange\\Server"
#define LBSEPERATOR   "____________________________________________________________________________________________________"
#define DataDirectory "C:\\ImportDB"

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define AUTH_CMD_FAILED     1
#define AUTH_CMD_OK         2
#define AUTH_CMD_SUCCESS    3
#define AUTH_CMD_DISCONNECT 4
#define AUTH_CMD_UNKNOWN    5

#define COMMAND_RESULT_DISCONNECT 1
#define COMMAND_RESULT_OK         2
#define COMMAND_RESULT_ERROR      3
#define COMMAND_RESULT_UNKNOWN    4

//---------------------(Instance Definitions & Dialog Handle Definitions)
HINSTANCE MainInstance = NULL; 
HWND ServerDialog_hWnd = NULL;

//---------------------(Global Variables)
SQLBasics WebPortalIndex;

int giMaxConnections   = 0;

DWORD glListenPort     = 0;
DWORD glTCPLoopDelay   = 0;

FILE *gfSessionLog = NULL;

char *gsBaseCommKey  = "6riupiekieB8uphiuspi0tr6azl2piAth6us6ieko2zoap2818UviapHlEvo5joe";
char gsSessionLogDir[256];
char gsSQLIndexServer[255];
char gsSQLIndexUserID[255];
char gsSQLIndexPassword[255];
char gsSQLIndexDatabase[255];
char gsSQLIndexDriver[255];

bool gbIsServerDialogOpen = false;
bool gbApplicationRunning = false;
bool gbKillApplication = false;
bool gbDebugMode = false;

struct _ServerDialogInfo{
    HWND ServerList_hWnd;
    HMENU Menu_hWnd;
}; _ServerDialogInfo SDI;

//---------------------(Dialog Prototypes)
BOOL CALLBACK ServerDialog(HWND, UINT, WPARAM, LPARAM);

//---------------------(Function Prototypes)
bool StopServer(void);
bool StartServer(void);

int AuthenticateClient(int);

bool ServerSend(int, char *, int);
bool SimpleServerSend(int, char *);
int ProcessCommand(int, char *, int);
void CreateFolderStructure(char *);
bool xMainEntry(void);
bool WaitOnApplicationToExit(void);
bool Initialize(void);
bool Uninitialize(void);
void WriteLog(char *);
void FatalError(char *);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

